module State.Loading.Load where

import Affection

import SDL (($=), get)
import qualified SDL
import qualified SDL.Internal.Numbered as SDL
import qualified SDL.Raw.Video as SDL (glSetAttribute)
import qualified SDL.Raw.Enum as SDL

import qualified Graphics.Rendering.OpenGL as GL
import qualified Graphics.GL as GLRaw

import Foreign.Marshal.Array

import qualified Data.ByteString as B
import qualified Data.ByteString.Char8 as B8

import Control.Concurrent.STM

-- internal imports

import Types
import Map

initLoadLoad
  :: GameData
  -> Affection ()
initLoadLoad gd = do
  stateData <- liftIO (TestData <$> constructMap testLevelDesc 0)
  liftIO $ atomically $ do
    writeTVar (gameStateData gd) stateData
    writeTVar (gameState gd) (MainGame Test)
