{-# LANGUAGE MultiParamTypeClasses #-}
{-# LANGUAGE OverloadedStrings #-}
module StateMachine where

import Affection

import Control.Monad (void)

-- internal imports

import Types

import State.Loading

instance StateMachine GameData State where

  smLoad Loading = initLoadLoad
  smLoad x       = error ("State load not yet implemented: " <> show x)

  smUpdate Loading = initLoadUpdate
  smUpdate x       = error ("State update not yet implemented: " <> show x)

  smDraw Loading = initLoadDraw
  smDraw x       = error ("State draw not yet implemented: " <> show x)

  smEvent _ gd evs = do
    let Subsystems w m k _ = gameSubsystems gd
    void . (consumeSDLEvents k) =<<
      consumeSDLEvents m =<<
      consumeSDLEvents w evs

  smClean x = error ("State clean not yet implemented: " <> show x)
